diff --git a/game/core/src/main/java/net/minecraft/core/util/linalg/Vector3.java b/game/core/src/main/java/net/minecraft/core/util/linalg/Vector3.java
new file mode 100644
index 000000000..0bd7d5a16
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/linalg/Vector3.java
@@ -0,0 +1,404 @@
+package net.minecraft.core.util.linalg;
+
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.pool.ObjectPool;
+import net.minecraft.core.util.pool.Poolable;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Objects;
+
+public class Vector3
+    implements Poolable<Vector3>
+{
+    private static final @NotNull ObjectPool<Vector3> POOL = new ObjectPool<>(Vector3::new);
+
+    /**
+     * The X component of this vector.
+     */
+    public double x;
+
+    /**
+     * The Y component of this vector.
+     */
+    public double y;
+
+    /**
+     * The Z component of this vector.
+     */
+    public double z;
+
+    /**
+     * Produces a pooled vector with the given components.
+     */
+    public static @NotNull Vector3 fromPool(final double x, final double y, final double z) {
+        return Vector3.POOL.get().set(x, y, z);
+    }
+
+    /**
+     * Produces a pooled unit vector on the X axis.
+     */
+    public static @NotNull Vector3 unitX() {
+        return Vector3.fromPool(1.0, 0.0, 0.0);
+    }
+
+    /**
+     * Produces a pooled unit vector on the Y axis.
+     */
+    public static @NotNull Vector3 unitY() {
+        return Vector3.fromPool(0.0, 1.0, 0.0);
+    }
+
+    /**
+     * Produces a pooled unit vector on the Z axis.
+     */
+    public static @NotNull Vector3 unitZ() {
+        return Vector3.fromPool(0.0, 0.0, 1.0);
+    }
+
+    private Vector3() {
+        this.x = 0.0;
+        this.y = 0.0;
+        this.z = 0.0;
+    }
+
+    @Override
+    public @NotNull ObjectPool<Vector3> getPool() {
+        return Vector3.POOL;
+    }
+
+    @Override
+    public void set(final @NotNull Vector3 other) {
+        this.x = other.x;
+        this.y = other.y;
+        this.z = other.z;
+    }
+
+    /**
+     * Sets the values of this vector.
+     */
+    public @NotNull Vector3 set(final double x, final double y, final double z) {
+        this.x = x;
+        this.y = y;
+        this.z = z;
+
+        return this;
+    }
+
+    /**
+     * Extends this three-dimensional vector into a four-dimensional vector.
+     */
+    public @NotNull Vector4 extend(final double w) {
+        return Vector4.fromPool(this.x, this.y, this.z, w);
+    }
+
+    /**
+     * Calculates the cross product of this and another vector.
+     */
+    public @NotNull Vector3 cross(final @NotNull Vector3 other) {
+        return Vector3.fromPool(
+            (this.y * other.z) - (this.z * other.y),
+            (this.z * other.x) - (this.x * other.z),
+            (this.x * other.y) - (this.y * other.x)
+        );
+    }
+
+    /**
+     * Performs the unary negation operation.
+     */
+    public @NotNull Vector3 neg() {
+        return this.copyPooled().negInPlace();
+    }
+
+    /**
+     * Performs the unary negation operation, modifying this vector in place.
+     */
+    public @NotNull Vector3 negInPlace() {
+        this.x = -this.x;
+        this.y = -this.y;
+        this.z = -this.z;
+
+        return this;
+    }
+
+    /**
+     * Adds another vector to this vector.
+     */
+    public @NotNull Vector3 add(final @NotNull Vector3 other) {
+        return this.copyPooled().addInPlace(other);
+    }
+
+    /**
+     * Adds another vector to this vector, modifying it in place.
+     */
+    public @NotNull Vector3 addInPlace(final @NotNull Vector3 other) {
+        this.x += other.x;
+        this.y += other.y;
+        this.z += other.z;
+
+        return this;
+    }
+
+    /**
+     * Subtracts another vector from this vector.
+     */
+    public @NotNull Vector3 sub(final @NotNull Vector3 other) {
+        return this.copyPooled().subInPlace(other);
+    }
+
+    /**
+     * Subtracts another vector from this vector, modifying it in place.
+     */
+    public @NotNull Vector3 subInPlace(final @NotNull Vector3 other) {
+        this.x -= other.x;
+        this.y -= other.y;
+        this.z -= other.z;
+
+        return this;
+    }
+
+    /**
+     * Returns this vector as an array.
+     */
+    public double @NotNull [] asArray() {
+        return new double[] { this.x, this.y, this.z };
+    }
+
+    /**
+     * Multiplies this vector by a scalar value.
+     */
+    public @NotNull Vector3 mult(final double value) {
+        return this.copyPooled().multInPlace(value);
+    }
+
+    /**
+     * Multiplies this vector by a scalar value, modifying it in place.
+     */
+    public @NotNull Vector3 multInPlace(final double value) {
+        this.x *= value;
+        this.y *= value;
+        this.z *= value;
+
+        return this;
+    }
+
+    /**
+     * Divides this vector by a scalar value.
+     */
+    public @NotNull Vector3 div(final double value) {
+        return this.copyPooled().divInPlace(value);
+    }
+
+    /**
+     * Divides this vector by a scalar value, modifying it in place.
+     */
+    public @NotNull Vector3 divInPlace(final double value) {
+        this.x /= value;
+        this.y /= value;
+        this.z /= value;
+
+        return this;
+    }
+
+    /**
+     * Calculates the dot product of this and another vector.
+     */
+    public double dot(final @NotNull Vector3 other) {
+        return this.x * other.x + this.y * other.y + this.z * other.z;
+    }
+
+    /**
+     * Calculates the squared magnitude of this vector.
+     * <p>
+     * This does not perform a square root operation, and so can be used to more efficiently compare the magnitudes
+     * of two vectors.
+     */
+    public double squaredMagnitude() {
+        return this.dot(this);
+    }
+
+    /**
+     * Calculates the magnitude of this vector.
+     */
+    public double magnitude() {
+        return Math.sqrt(this.squaredMagnitude());
+    }
+
+    /**
+     * Calculates the angle between this and another vector in radians.
+     */
+    public double angle(final @NotNull Vector3 other) {
+        return Math.atan2(this.cross(other).magnitude(), this.dot(other));
+    }
+
+    /**
+     * Returns a vector with the same direction, but a magnitude of 1.
+     */
+    public @NotNull Vector3 normalize() {
+        return this.normalize(1.0);
+    }
+
+    /**
+     * Returns a vector with the same direction and a given magnitude.
+     */
+    public @NotNull Vector3 normalize(final double magnitude) {
+        return this.mult(magnitude / this.magnitude());
+    }
+
+    /**
+     * Returns the squared distance between two vectors.
+     * <p>
+     * This does not perform a square root operation, and so can be used to more efficiently compare the distances
+     * of vectors.
+     */
+    public double squaredDistance(final @NotNull Vector3 other) {
+        return other.sub(this).squaredMagnitude();
+    }
+
+    /**
+     * Returns the distance between two vectors.
+     */
+    public double distance(final @NotNull Vector3 other) {
+        return Math.sqrt(this.squaredDistance(other));
+    }
+
+    /**
+     * Linearly interpolates towards another vector by the specified amount.
+     */
+    public @NotNull Vector3 lerp(final @NotNull Vector3 other, final double amount) {
+        return Vector3.fromPool(
+            this.x + (other.x - this.x) * amount,
+            this.y + (other.y - this.y) * amount,
+            this.z + (other.z - this.z) * amount
+        );
+    }
+
+    /**
+     * Calculates the intersection between a line segment defined by this and another vector, and a plane perpendicular
+     * to the X axis.
+     * @param other The end-point of the line segment.
+     * @param x The X-axis position of the plane.
+     * @return The intersection point, or null if no point exists.
+     */
+    public @Nullable Vector3 clipX(final @NotNull Vector3 other, final double x) {
+        final @NotNull Vector3 delta = other.sub(this);
+        if (delta.x * delta.x < 1.0E-7D) {
+            return null;
+        }
+
+        final double percentage = (x - this.x) - delta.x;
+
+        if (percentage < 0.0 || percentage > 1.0) {
+            return null;
+        } else {
+            return Vector3.fromPool(this.x + delta.x * percentage, this.y + delta.y * percentage, this.z + delta.z * percentage);
+        }
+    }
+
+    /**
+     * Calculates the intersection between a line segment defined by this and another vector, and a plane perpendicular
+     * to the Y axis.
+     * @param other The end-point of the line segment.
+     * @param y The Y-axis position of the plane.
+     * @return The intersection point, or null if no point exists.
+     */
+    public @Nullable Vector3 clipY(final @NotNull Vector3 other, final double y) {
+        final @NotNull Vector3 delta = other.sub(this);
+        if (delta.y * delta.y < 1.0E-7D) {
+            return null;
+        }
+
+        final double percentage = (y - this.y) - delta.y;
+
+        if (percentage < 0.0 || percentage > 1.0) {
+            return null;
+        } else {
+            return Vector3.fromPool(this.x + delta.x * percentage, this.y + delta.y * percentage, this.z + delta.z * percentage);
+        }
+    }
+
+    /**
+     * Calculates the intersection between a line segment defined by this and another vector, and a plane perpendicular
+     * to the Z axis.
+     * @param other The end-point of the line segment.
+     * @param z The Z-axis position of the plane.
+     * @return The intersection point, or null if no point exists.
+     */
+    public @Nullable Vector3 clipZ(final @NotNull Vector3 other, final double z) {
+        final @NotNull Vector3 delta = other.sub(this);
+        if (delta.z * delta.z < 1.0E-7D) {
+            return null;
+        }
+
+        final double percentage = (z - this.z) - delta.z;
+
+        if (percentage < 0.0 || percentage > 1.0) {
+            return null;
+        } else {
+            return Vector3.fromPool(this.x + delta.x * percentage, this.y + delta.y * percentage, this.z + delta.z * percentage);
+        }
+    }
+
+    /**
+     * Rotates the vector by the given angle in radians around the X axis.
+     */
+    public @NotNull Vector3 rotX(final float radians) {
+        final float cos = MathHelper.cos(radians);
+        final float sin = MathHelper.sin(radians);
+
+        return Vector3.fromPool(
+            this.x,
+            this.y * cos + this.z * sin,
+            this.z * cos - this.y * sin
+        );
+    }
+
+    /**
+     * Rotates the vector by the given angle in radians around the Y axis.
+     */
+    public @NotNull Vector3 rotY(final float radians) {
+        final float cos = MathHelper.cos(radians);
+        final float sin = MathHelper.sin(radians);
+
+        return Vector3.fromPool(
+            this.x * cos + this.z * sin,
+            this.y,
+            this.z * cos - this.x * sin
+        );
+    }
+
+    /**
+     * Rotates the vector by the given angle in radians around the Z axis.
+     */
+    public @NotNull Vector3 rotZ(final float radians) {
+        final float cos = MathHelper.cos(radians);
+        final float sin = MathHelper.sin(radians);
+
+        return Vector3.fromPool(
+           this.x * cos + this.y * sin,
+           this.y * cos - this.x * sin,
+           this.z
+        );
+    }
+
+    @Override
+    public boolean equals(final Object obj) {
+        if (obj instanceof Vector3) {
+            final @NotNull Vector3 other = (Vector3) obj;
+
+            return this.x == other.x && this.y == other.y && this.z == other.z;
+        } else {
+            return false;
+        }
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(this.x, this.y, this.z);
+    }
+
+    @Override
+    public @NotNull String toString() {
+        return "[ " + this.x + ", " + this.y + ", " + this.z + " ]";
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/util/linalg/Vector4.java b/game/core/src/main/java/net/minecraft/core/util/linalg/Vector4.java
new file mode 100644
index 000000000..b57beeb8e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/linalg/Vector4.java
@@ -0,0 +1,412 @@
+package net.minecraft.core.util.linalg;
+
+import net.minecraft.core.util.pool.ObjectPool;
+import net.minecraft.core.util.pool.Poolable;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Objects;
+
+public class Vector4
+    implements Poolable<Vector4>
+{
+    private static final @NotNull ObjectPool<Vector4> POOL = new ObjectPool<>(Vector4::new);
+
+    /**
+     * The X component of this vector.
+     */
+    public double x;
+
+    /**
+     * The Y component of this vector.
+     */
+    public double y;
+
+    /**
+     * The Z component of this vector.
+     */
+    public double z;
+
+    /**
+     * The W component of this vector.
+     */
+    public double w;
+
+    /**
+     * Produces a pooled vector with the given components.
+     */
+    public static @NotNull Vector4 fromPool(final double x, final double y, final double z, final double w) {
+        return Vector4.POOL.get().set(x, y, z, w);
+    }
+
+    /**
+     * Produces a pooled unit vector on the X axis.
+     */
+    public static @NotNull Vector4 unitX() {
+        return Vector4.fromPool(1.0, 0.0, 0.0, 0.0);
+    }
+
+    /**
+     * Produces a pooled unit vector on the Y axis.
+     */
+    public static @NotNull Vector4 unitY() {
+        return Vector4.fromPool(0.0, 1.0, 0.0, 0.0);
+    }
+
+    /**
+     * Produces a pooled unit vector on the Z axis.
+     */
+    public static @NotNull Vector4 unitZ() {
+        return Vector4.fromPool(0.0, 0.0, 1.0, 0.0);
+    }
+
+    /**
+     * Produces a pooled unit vector on the W axis.
+     */
+    public static @NotNull Vector4 unitW() {
+        return Vector4.fromPool(0.0, 0.0, 0.0, 1.0);
+    }
+
+    private Vector4() {
+        this.x = 0.0;
+        this.y = 0.0;
+        this.z = 0.0;
+        this.w = 0.0;
+    }
+
+    @Override
+    public @NotNull ObjectPool<Vector4> getPool() {
+        return Vector4.POOL;
+    }
+
+    @Override
+    public void set(final @NotNull Vector4 other) {
+        this.x = other.x;
+        this.y = other.y;
+        this.z = other.z;
+        this.w = other.w;
+    }
+
+    /**
+     * Sets the values of the vector.
+     */
+    public @NotNull Vector4 set(final double x, final double y, final double z, final double w) {
+        this.x = x;
+        this.y = y;
+        this.z = z;
+        this.w = w;
+
+        return this;
+    }
+
+    /**
+     * Truncates this four-dimensional vector into a three-dimensional vector.
+     */
+    public @NotNull Vector3 truncate() {
+        return Vector3.fromPool(this.x, this.y, this.z);
+    }
+
+    /**
+     * Performs the unary negation operation.
+     */
+    public @NotNull Vector4 neg() {
+        return this.copyPooled().negInPlace();
+    }
+
+    /**
+     * Performs the unary negation operation, modifying this vector in place.
+     */
+    public @NotNull Vector4 negInPlace() {
+        this.x = -this.x;
+        this.y = -this.y;
+        this.z = -this.z;
+        this.w = -this.w;
+
+        return this;
+    }
+
+    /**
+     * Adds another vector to this vector.
+     */
+    public @NotNull Vector4 add(final @NotNull Vector4 other) {
+        return this.copyPooled().addInPlace(other);
+    }
+
+    /**
+     * Adds another vector to this vector, modifying it in place.
+     */
+    public @NotNull Vector4 addInPlace(final @NotNull Vector4 other) {
+        this.x += other.x;
+        this.y += other.y;
+        this.z += other.z;
+        this.w += other.w;
+
+        return this;
+    }
+
+    /**
+     * Subtracts another vector from this vector.
+     */
+    public @NotNull Vector4 sub(final @NotNull Vector4 other) {
+        return this.copyPooled().subInPlace(other);
+    }
+
+    /**
+     * Subtracts another vector from this vector, modifying it in place.
+     */
+    public @NotNull Vector4 subInPlace(final @NotNull Vector4 other) {
+        this.x -= other.x;
+        this.y -= other.y;
+        this.z -= other.z;
+        this.w -= other.w;
+
+        return this;
+    }
+
+    /**
+     * Returns this vector as an array.
+     */
+    public double @NotNull [] asArray() {
+        return new double[] { this.x, this.y, this.z, this.w };
+    }
+
+    /**
+     * Multiplies this vector by a scalar value.
+     */
+    public @NotNull Vector4 mult(final double value) {
+        return this.copyPooled().multInPlace(value);
+    }
+
+    /**
+     * Multiplies this vector by a scalar value, modifying it in place.
+     */
+    public @NotNull Vector4 multInPlace(final double value) {
+        this.x *= value;
+        this.y *= value;
+        this.z *= value;
+        this.w *= value;
+
+        return this;
+    }
+
+    /**
+     * Divides this vector by a scalar value.
+     */
+    public @NotNull Vector4 div(final double value) {
+        return this.copyPooled().divInPlace(value);
+    }
+
+    /**
+     * Divides this vector by a scalar value, modifying it in place.
+     */
+    public @NotNull Vector4 divInPlace(final double value) {
+        this.x /= value;
+        this.y /= value;
+        this.z /= value;
+        this.w /= value;
+
+        return this;
+    }
+
+    /**
+     * Calculates the dot product of this and another vector.
+     */
+    public double dot(final @NotNull Vector4 other) {
+        return this.x * other.x + this.y * other.y + this.z * other.z + this.w * other.w;
+    }
+
+    /**
+     * Calculates the squared magnitude of this vector.
+     * <p>
+     * This does not perform a square root operation, and so can be used to more efficiently compare the magnitudes
+     * of two vectors.
+     */
+    public double squaredMagnitude() {
+        return this.dot(this);
+    }
+
+    /**
+     * Calculates the magnitude of this vector.
+     */
+    public double magnitude() {
+        return Math.sqrt(this.squaredMagnitude());
+    }
+
+    /**
+     * Calculates the angle between this and another vector in radians.
+     */
+    public double angle(final @NotNull Vector4 other) {
+        return Math.acos(this.dot(other)) / (this.magnitude() * other.magnitude());
+    }
+
+    /**
+     * Returns a vector with the same direction, but a magnitude of 1.
+     */
+    public @NotNull Vector4 normalize() {
+        return this.normalize(1.0);
+    }
+
+    /**
+     * Returns a vector with the same direction and a given magnitude.
+     */
+    public @NotNull Vector4 normalize(final double magnitude) {
+        return this.mult(magnitude / this.magnitude());
+    }
+
+    /**
+     * Returns the squared distance between two vectors.
+     * <p>
+     * This does not perform a square root operation, and so can be used to more efficiently compare the distances
+     * of vectors.
+     */
+    public double squaredDistance(final @NotNull Vector4 other) {
+        return other.sub(this).squaredMagnitude();
+    }
+
+    /**
+     * Returns the distance between two vectors.
+     */
+    public double distance(final @NotNull Vector4 other) {
+        return Math.sqrt(this.squaredDistance(other));
+    }
+
+    /**
+     * Linearly interpolates towards another vector by the specified amount.
+     */
+    public @NotNull Vector3 lerp(final @NotNull Vector3 other, final double amount) {
+        return Vector3.fromPool(
+            this.x + (other.x - this.x) * amount,
+            this.y + (other.y - this.y) * amount,
+            this.z + (other.z - this.z) * amount
+        );
+    }
+
+    /**
+     * Calculates the intersection between a line segment defined by this and another vector, and a plane perpendicular
+     * to the X axis.
+     * @param other The end-point of the line segment.
+     * @param x The X-axis position of the plane.
+     * @return The intersection point, or null if no point exists.
+     */
+    public @Nullable Vector4 clipX(final @NotNull Vector4 other, final double x) {
+        final @NotNull Vector4 delta = other.sub(this);
+        if (delta.x * delta.x < 1.0E-7D) {
+            return null;
+        }
+
+        final double percentage = (x - this.x) - delta.x;
+
+        if (percentage < 0.0 || percentage > 1.0) {
+            return null;
+        } else {
+            return Vector4.fromPool(
+                this.x + delta.x * percentage,
+                this.y + delta.y * percentage,
+                this.z + delta.z * percentage,
+                this.w + delta.w * percentage
+            );
+        }
+    }
+
+    /**
+     * Calculates the intersection between a line segment defined by this and another vector, and a plane perpendicular
+     * to the Y axis.
+     * @param other The end-point of the line segment.
+     * @param y The Y-axis position of the plane.
+     * @return The intersection point, or null if no point exists.
+     */
+    public @Nullable Vector4 clipY(final @NotNull Vector4 other, final double y) {
+        final @NotNull Vector4 delta = other.sub(this);
+        if (delta.y * delta.y < 1.0E-7D) {
+            return null;
+        }
+
+        final double percentage = (y - this.y) - delta.y;
+
+        if (percentage < 0.0 || percentage > 1.0) {
+            return null;
+        } else {
+            return Vector4.fromPool(
+                this.x + delta.x * percentage,
+                this.y + delta.y * percentage,
+                this.z + delta.z * percentage,
+                this.w + delta.w * percentage
+            );
+        }
+    }
+
+    /**
+     * Calculates the intersection between a line segment defined by this and another vector, and a plane perpendicular
+     * to the Z axis.
+     * @param other The end-point of the line segment.
+     * @param z The Z-axis position of the plane.
+     * @return The intersection point, or null if no point exists.
+     */
+    public @Nullable Vector4 clipZ(final @NotNull Vector4 other, final double z) {
+        final @NotNull Vector4 delta = other.sub(this);
+        if (delta.z * delta.z < 1.0E-7D) {
+            return null;
+        }
+
+        final double percentage = (z - this.z) - delta.z;
+
+        if (percentage < 0.0 || percentage > 1.0) {
+            return null;
+        } else {
+            return Vector4.fromPool(
+                this.x + delta.x * percentage,
+                this.y + delta.y * percentage,
+                this.z + delta.z * percentage,
+                this.w + delta.w * percentage
+            );
+        }
+    }
+
+    /**
+     * Calculates the intersection between a line segment defined by this and another vector, and a plane perpendicular
+     * to the W axis.
+     * @param other The end-point of the line segment.
+     * @param w The W-axis position of the plane.
+     * @return The intersection point, or null if no point exists.
+     */
+    public @Nullable Vector4 clipW(final @NotNull Vector4 other, final double w) {
+        final @NotNull Vector4 delta = other.sub(this);
+        if (delta.w * delta.w < 1.0E-7D) {
+            return null;
+        }
+
+        final double percentage = (w - this.w) - delta.w;
+
+        if (percentage < 0.0 || percentage > 1.0) {
+            return null;
+        } else {
+            return Vector4.fromPool(
+                this.x + delta.x * percentage,
+                this.y + delta.y * percentage,
+                this.z + delta.z * percentage,
+                this.w + delta.w * percentage
+            );
+        }
+    }
+
+    @Override
+    public boolean equals(final Object obj) {
+        if (obj instanceof Vector4) {
+            final @NotNull Vector4 other = (Vector4) obj;
+
+            return this.x == other.x && this.y == other.y && this.z == other.z && this.w == other.w;
+        } else {
+            return false;
+        }
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(this.x, this.y, this.z, this.w);
+    }
+
+    @Override
+    public String toString() {
+        return "[ " + this.x + ", " + this.y + ", " + this.z + ", " + this.w + " ]";
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java b/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
index 3135a9cb7..4e1529d67 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/AABB.java
@@ -1,14 +1,13 @@
 package net.minecraft.core.util.phys;
 
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.pool.ObjectPool;
+import net.minecraft.core.util.pool.Poolable;
+import org.jetbrains.annotations.NotNull;
 
-import java.util.ArrayList;
-import java.util.List;
+public class AABB implements Poolable<AABB> {
+    private static final @NotNull ObjectPool<AABB> POOL = new ObjectPool<>(() -> new AABB(0.0, 0.0, 0.0, 0.0, 0.0, 0.0));
 
-public class AABB
-{
-    private static final List<AABB> pool = new ArrayList<>();
-    private static int poolPointer = 0;
     public double minX;
     public double minY;
     public double minZ;
@@ -16,30 +15,36 @@ public class AABB
     public double maxY;
     public double maxZ;
 
+    @Deprecated
     public static AABB getPermanentBB(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
     {
         return new AABB(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
+    @Deprecated
     public static void deinitializePool()
     {
-        pool.clear();
-        poolPointer = 0;
+        AABB.POOL.free();
     }
 
+    @Deprecated
     public static void initializePool()
     {
-        poolPointer = 0;
+        AABB.POOL.reset();
     }
 
+    @Deprecated
     public static AABB getTemporaryBB(double minX, double minY, double minZ, double maxX,
                                       double maxY, double maxZ)
     {
-        if(poolPointer >= pool.size())
-        {
-            pool.add(getPermanentBB(0.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.0D));
-        }
-        return pool.get(poolPointer++).set(minX, minY, minZ, maxX, maxY, maxZ);
+        return AABB.POOL.get().set(minX, minY, minZ, maxX, maxY, maxZ);
+    }
+
+    public static @NotNull AABB fromPool(
+        final double minX, final double minY, final double minZ,
+        final double maxX, final double maxY, final double maxZ
+    ) {
+        return AABB.POOL.get().set(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
     private AABB(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
@@ -52,6 +57,21 @@ public class AABB
         this.maxZ = maxZ;
     }
 
+    @Override
+    public @NotNull ObjectPool<AABB> getPool() {
+        return AABB.POOL;
+    }
+
+    @Override
+    public void set(final @NotNull AABB other) {
+        this.minX = other.minX;
+        this.minY = other.minY;
+        this.minZ = other.minZ;
+        this.maxX = other.maxX;
+        this.maxY = other.maxY;
+        this.maxZ = other.maxZ;
+    }
+
     public AABB set(double minX, double minY, double minZ, double maxX, double maxY, double maxZ)
     {
         this.minX = minX;
@@ -95,7 +115,7 @@ public class AABB
         {
             maxZ += stretchZ;
         }
-        return getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
+        return fromPool(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
     public AABB grow(double d, double d1, double d2)
@@ -106,12 +126,12 @@ public class AABB
         double d6 = maxX + d;
         double d7 = maxY + d1;
         double d8 = maxZ + d2;
-        return getTemporaryBB(d3, d4, d5, d6, d7, d8);
+        return fromPool(d3, d4, d5, d6, d7, d8);
     }
 
     public AABB cloneMove(double offX, double offY, double offZ)
     {
-        return getTemporaryBB(minX + offX, minY + offY, minZ + offZ, maxX + offX, maxY + offY, maxZ + offZ);
+        return fromPool(minX + offX, minY + offY, minZ + offZ, maxX + offX, maxY + offY, maxZ + offZ);
     }
 
     public double clipXCollide(AABB aabb, double d)
@@ -268,7 +288,7 @@ public class AABB
         if (n3 > 0.0) {
             maxZ -= n3;
         }
-        return getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
+        return fromPool(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
     public AABB getInsetBoundingBox(double d, double d1, double d2)
@@ -279,16 +299,18 @@ public class AABB
         double d6 = maxX - d;
         double d7 = maxY - d1;
         double d8 = maxZ - d2;
-        return getTemporaryBB(d3, d4, d5, d6, d7, d8);
+        return fromPool(d3, d4, d5, d6, d7, d8);
     }
 
+    @Deprecated
     public AABB copy()
     {
-        return getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
+        return fromPool(minX, minY, minZ, maxX, maxY, maxZ);
     }
 
+    @Deprecated
     public AABB copyPermanent() {
-        return getPermanentBB(minX, minY, minZ, maxX, maxY, maxZ);
+        return fromPool(minX, minY, minZ, maxX, maxY, maxZ).copyUnpooled();
     }
 
 	public HitResult clip(Vec3 start, Vec3 end) {
diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/HitResult.java b/game/core/src/main/java/net/minecraft/core/util/phys/HitResult.java
index ea0eab1b2..686af883e 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/HitResult.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/HitResult.java
@@ -20,7 +20,7 @@ public class HitResult
         this.y = y;
         this.z = z;
         this.side = side;
-        location = Vec3.getTempVec3(vec3.x, vec3.y, vec3.z);
+        location = Vec3.fromPool(vec3.x, vec3.y, vec3.z);
         entity = null;
     }
 
@@ -32,7 +32,7 @@ public class HitResult
         side = Side.NONE;
         hitType = HitType.ENTITY;
         this.entity = entity;
-        location = Vec3.getTempVec3(entity.x, entity.y, entity.z);
+        location = Vec3.fromPool(entity.x, entity.y, entity.z);
     }
 
     public double distanceToSquared(final Entity entity) {
